﻿Option Strict On
Option Explicit On
'Copyright (c) 1994-2010 by AppliTech, Inc. All Rights Reserved.

Imports System '基本 Imports
'Imports System.Text
'Imports System.Runtime.InteropServices
'Imports System.Threading
#If LocalOrOp OrElse Not CentralOrOp Then
Imports System.Windows.Forms
#End If

Friend Class Ae_MsgL0

    'Message Library V10.60.25.32 'ここはレベルアップの際に変更されます。
    '
    'このモジュールの変更履歴:
    '
    'V7.60.12.2 における変更。
    '
    '  - Ae_MsgL0 を Module から Class に変更しました。
    '     この結果､ このモジュールをカスタマイズする方法として､ 
    '   従来のようにこのモジュールを修正してしまう道の他に､ 
    '   このクラスを継承するサブクラスを作成する道ができました。
    '
    '  - 以下の定数名を変更しました。
    '     EXCEPTION_HOOKMETHOD_LOCALOROP → EXCEPTION_HookMethodLocalOrOp
    '     EXCEPTION_HOOKMETHOD_CENTRAL → EXCEPTION_HookMethodCentral
    '     EXCEPTION_THISSYSTEM_LOCALOROP → EXCEPTION_ThisSystemLocalOrOp
    '     EXCEPTION_THISSYSTEM_CENTRAL → EXCEPTION_ThisSystemCentral
    '     EXCEPTION_HOOKMETHOD_LOCALOROP_SKIPABLE → EXCEPTION_HookMethodLocalOrOpSkipable
    '     EXCEPTION_HOOKMETHOD_CENTRAL_SKIPABLE → EXCEPTION_HookMethodCentralSkipable
    '     LOG_STANDARD → LOG_Standard
    '     LOG_EXCEPTIONSKIP → LOG_ExceptionSkip
    '     LOG_EXCEPTIONEXIT → LOG_ExceptionExit
    '
    'V7.60.21.08 における変更。
    '
    '  - fB 以外の 14 個の ReadOnly 変数を Shared ReadOnly 変数に変更しました。
    '
    'V7.60.22.04 における変更。
    '
    '  - 誤って､ V7.60.21.08 において､ Ae_MsgL0.vb の中の ReadOnly 変数 (fB 以外の 14 個) を
    '   Shared ReadOnly 変数に変更しましたが､ これを元の Shared でない ReadOnly 変数に戻しました。
    '    これは､ Ae_MsgL0.vb の子クラスの中で､ 以下のように Shadows の指定をすることで､ ReadOnly 
    '   変数の値のカスタマイズを可能にするためです。
    '
    '    Friend Shadows ReadOnly COLOR_BrightON As System.Drawing.Color = System.Drawing.Color.Cyan
    '
    'V7.60.22.57 における変更。
    '
    '  - AE_StartUp を Function から Sub に変更しました。
    '
    'V7.60.23.10 における変更。
    '
    '  - VB.NET から C# に変換しやすいプログラムコードに変更しました。
    '  - AE_MsgBox において Optional パラメタの使用を止めて､ オーバロードを使うようにしました。
    '
    'V7.60.23.28 における変更。
    '
    '  - 条件付きコンパイル定数 JavaDotNet をサポートしました。この指定によって Java との相互運用が可能になります。
    '
    'V7.60.23.30 における変更。
    '
    '  - fB.MsgBox ではなく､ fB.MessageBoxShow を用いるように変更しました。
    '
    'V7.60.24.64 における変更。
    '
    '  - 定数 COMMAND_AppendChk の名前を COMMAND_AppendC に変更しました。
    '  - 定数 COMMAND_UpdateChk の名前を COMMAND_UpdateC に変更しました。
    '
    'V8.60.25.10 における変更。
    '
    '  - Visual Studio 2005 をサポートしました。
    '  - SmartDebug をサポートするための変更をしました。
    '  - 条件付きコンパイル定数 JavaDotNet を Servlet という名前に変更しました。
    '  - Remoting の URI を REMOTING に変更しました。
    '
    'V8.60.25.12 における変更。
    '
    '  - ReadOnly の変数 cn_ClBrightON の名前を COLOR_BrightON に変更しました。
    '  - ReadOnly の変数 cn_ClIncomplete の名前を COLOR_Incomplete に変更しました。
    '  - ReadOnly の変数 cn_ClCheckError の名前を COLOR_CheckError に変更しました。
    '  - ReadOnly の変数 cn_ClRelCheck の名前を COLOR_RelCheck に変更しました。
    '  - ReadOnly の変数 cn_ClChecked の名前を COLOR_Checked に変更しました。
    '  - ReadOnly の変数 cn_ClIndicator の名前を COLOR_Indicator に変更しました。
    '  - ReadOnly の変数 cn_ClNormalBack の名前を COLOR_NormalBack に変更しました。
    '  - ReadOnly の変数 cn_ClPromptStatus の名前を COLOR_PromptStatus に変更しました。
    '  - ReadOnly の変数 cn_ClErrorStatus の名前を COLOR_ErrorStatus に変更しました。
    '
    'V8.60.25.17 における変更。
    '
    '  - AE_StartUp を VS2005 に合うように修正しました。
    '
    'V8.60.25.19 における変更。
    '
    '  - コンパイル定数 SmartDebug を LclCnt に変更しました。
    '
    'V8.60.25.20 における変更。
    '
    '  - fB.ShowException によって表示するメッセージのヘッダ部分をカスタマイズ可能にしました。
    '
    'V8.60.25.21 における変更。
    '
    '  - コンパイル定数 Servlet を HttpDirect に変更しました。
    '  - tcp のサポートを追加しました。
    '  - 通信に関するセキュリティ機能を追加しました。
    '  - 通信に関する設定をアプリケーション構成ファイルから取得するようにしました。
    '  - Overridable Function AE_Configuration, AE_Login および AE_LoginSuccessed を追加しました。
    '
    'V9.60.25.32 における変更。
    '
    '  - Visual Studio 2008 をサポートしました。
    '
    'V9.60.25.32 における変更。
    '
    '  - コンパイル定数 LclCnt を使用しないように変更しました。
    '

    'Ae_MsgL0 (aeBase)
    'MANDALA 共通ライブラリモジュール (Project 固有)。
    '(★ このクラスは､ 必要に応じてオーバライドしてください)

    'FormBase オブジェクトへのポインタ。
    Friend ReadOnly fB As AppliTech.WorkFrame.FormBase '= pm_fB

    Friend Sub New(ByVal pm_fB As AppliTech.WorkFrame.FormBase)
        Me.fB = pm_fB
    End Sub 'New

    '★ 色 の値は定数 (Const) から ReadOnly 変数に変更されました。
    '置換え候補 Friend ReadOnly COLOR_BrightON As System.Drawing.Color = System.Drawing.Color.Cyan 'シアン = &HFFFF00
    Friend ReadOnly COLOR_BrightON As System.Drawing.Color = System.Drawing.Color.Yellow '黄色 = &HFFFF&
    '置換え候補 Friend ReadOnly COLOR_Incomplete As System.Drawing.Color = System.Drawing.Color.Blue '水色 = &HFFFF00
    '置換え候補 Friend ReadOnly COLOR_Incomplete As System.Drawing.Color = System.Drawing.Color.Black '黒色 = &H0&
    Friend ReadOnly COLOR_Incomplete As System.Drawing.Color = System.Drawing.Color.Teal '青緑色 = &H808000
    '置換え候補 Friend ReadOnly COLOR_CheckError As System.Drawing.Color = System.Drawing.Color.Salmon 'サーモン = &H7280FA
    Friend ReadOnly COLOR_CheckError As System.Drawing.Color = System.Drawing.Color.Red '赤色 = &HFF&
    Friend ReadOnly COLOR_RelCheck As System.Drawing.Color = System.Drawing.Color.Magenta '紫色 = &HFF00FF
    Friend ReadOnly COLOR_Checked As System.Drawing.Color = System.Drawing.Color.Black '黒色 = &H0&
    Friend ReadOnly COLOR_Indicator As System.Drawing.Color = System.Drawing.Color.White '白色 = &HFFFFFF
    Friend ReadOnly COLOR_NormalBack As System.Drawing.Color = System.Drawing.Color.White '白色 = &HFFFFFF
    '
    Friend ReadOnly COLOR_PromptStatus As System.Drawing.Color = System.Drawing.Color.Blue '青色 = &HFF0000
    Friend ReadOnly COLOR_ErrorStatus As System.Drawing.Color = System.Drawing.Color.Red '赤色 = &HFF&
    '
    'CommandCode
    Friend Const COMMAND_AppendC As Integer = 1
    Friend Const COMMAND_AppendChk As Integer = 1 '削除予定 (COMMAND_AppendC をお使いください)
    Friend Const COMMAND_Cancel As Integer = 2
    '削除 Friend Const COMMAND_CancelGu As Integer = 3 'nic 仕様
    Friend Const COMMAND_ClearDe As Integer = 4
    Friend Const COMMAND_ClearItm As Integer = 5
    Friend Const COMMAND_Copy As Integer = 6
    Friend Const COMMAND_CopyDe As Integer = 7
    '削除 Friend Const COMMAND_CopyItem As Integer = 8 'sgk 仕様
    '削除 Friend Const COMMAND_Ctrl As Integer = 9 'メニュータイトル
    Friend Const COMMAND_Cut As Integer = 10
    '削除 Friend Const COMMAND_DataMn As Integer = 11 'メニュータイトル
    Friend Const COMMAND_DeleteCm As Integer = 12
    Friend Const COMMAND_DeleteDe As Integer = 13
    Friend Const COMMAND_DeleteDR As Integer = 14 'sss 仕様
    '削除 Friend Const COMMAND_EditMn As Integer = 15 'メニュータイトル
    Friend Const COMMAND_EndCm As Integer = 16
    '削除 Friend Const COMMAND_EndEof As Integer = 17 'sgk 仕様
    Friend Const COMMAND_Execute As Integer = 18
    Friend Const COMMAND_Exit As Integer = 19
    Friend Const COMMAND_First As Integer = 20
    '削除 Friend Const COMMAND_GyomuMn As Integer = 21 'nic 仕様
    Friend Const COMMAND_Hardcopy As Integer = 22
    Friend Const COMMAND_Help As Integer = 23
    Friend Const COMMAND_Indicate As Integer = 24
    Friend Const COMMAND_InsertDe As Integer = 25
    '削除 Friend Const COMMAND_Jikkou As Integer = 26 'nic 仕様
    Friend Const COMMAND_Last As Integer = 27
    Friend Const COMMAND_Master As Integer = 28
    Friend Const COMMAND_NextCm As Integer = 29
    Friend Const COMMAND_NextItem As Integer = 30
    '削除 Friend Const COMMAND_NextLine As Integer = 31 'sgk 仕様
    '削除 Friend Const COMMAND_Oprt As Integer = 32 'メニュータイトル
    Friend Const COMMAND_Paste As Integer = 33
    Friend Const COMMAND_Prev As Integer = 34
    Friend Const COMMAND_PrevItem As Integer = 35
    '削除 Friend Const COMMAND_PrevLine As Integer = 36 'sgk 仕様
    Friend Const COMMAND_RelInf As Integer = 37
    Friend Const COMMAND_SearchCm As Integer = 38
    Friend Const COMMAND_SelectCm As Integer = 39
    '削除 Friend Const COMMAND_SelectGm As Integer = 40 'nic 仕様
    '削除 Friend Const COMMAND_SelectGu As Integer = 41 'nic 仕様
    Friend Const COMMAND_SList As Integer = 42
    Friend Const COMMAND_UndoDe As Integer = 43
    Friend Const COMMAND_UndoItem As Integer = 44
    Friend Const COMMAND_UpdateC As Integer = 45
    Friend Const COMMAND_UpdateChk As Integer = 45 '削除予定 (COMMAND_UpdateC をお使いください)
    '削除 Friend Const COMMAND_MenuTitle As Integer = 46 'メニュータイトル
    Friend Const COMMAND_ItemCopy As Integer = 47
    Friend Const COMMAND_ItemCut As Integer = 48
    Friend Const COMMAND_ItemPaste As Integer = 49
    Friend Const COMMAND_SelectCl As Integer = 50

    'セントラル / ローカル / ワンピース共通

    '★ Windows 2003 では､ MessageBeep が効かない。
    '置換 Private Declare Function MessageBeep Lib "user32" Alias "MessageBeep" (ByVal wType As Integer) As Integer
    '★ Beep を用いるとパソコンによっては､ 数値の入力が乱れることがあった。'V7.60.23.46
    '置換 Private Declare Function Beep Lib "kernel32" Alias "Beep" (ByVal dwFreq As Integer, ByVal dwDuration As Integer) As Integer
    Private Declare Function MessageBeep Lib "user32" Alias "MessageBeep" (ByVal wType As Integer) As Integer 'V7.60.23.46

    Friend Overridable Sub AE_Beep()
#If LocalOrOp OrElse Not CentralOrOp Then '"ローカル / ワンピース" 向け専用部分の開始。
        '★ Windows 2003 では､ MessageBeep が効かない。
        MessageBeep(-1) 'V7.60.23.46
#End If '"ローカル / ワンピース" 向け専用部分の終了。
    End Sub 'AE_Beep

    'ログ用のアプリケーションイベント
    '
    'パラメタ pm_LogCode の内容
    '  ローカルピース / ワンピース側のフックメソッドの中で発生した例外の終了処理。
    'Friend Const EXCEPTION_HookMethodLocalOrOp As Integer = 0 '★ これはあり得ない
    '  セントルピース側のフックメソッドの中で発生した例外の処理 (処理を継続)。
    Friend Const EXCEPTION_HookMethodCentral As Integer = 1 '★ これはセントル側での一次処理の場合､ この後この例外情報はローカル側に転送
    '  ローカルピース / ワンピース側の当システム内で発生した例外の終了処理。
    Friend Const EXCEPTION_ThisSystemLocalOrOp As Integer = 2
    '  セントルピース側の当システム内で発生した例外の処理 (セントル側では処理を継続､ ローカル側では終了処理)。
    Friend Const EXCEPTION_ThisSystemCentral As Integer = 3 '★ セントル側での一次処理､ およびローカル側に転送されたセントル側の例外の処理
    '
    '  ローカルピース / ワンピース側のフックメソッドの中で発生した例外の処理。
    Friend Const EXCEPTION_HookMethodLocalOrOpSkipable As Integer = 4 '例外スキップの扱いにするか終了処理にするかを選択できる。
    '  セントルピース側のフックメソッドの中で発生した例外の処理。
    Friend Const EXCEPTION_HookMethodCentralSkipable As Integer = 5 '例外スキップの扱いにするか終了処理にするかを選択できる。? ローカル側に転送されたセントル側の例外の場合
    '
    'パラメタ pm_ex の内容
    '  System.Exception オブジェクト。ただし､ ローカル側に転送されたセントル側の例外の場合だけは､ Nothing となることに注意。
    '
    'パラメタ ps_LogMsg の内容
    '  標準処理が選択された場合に､ 規定のダイアログに表示されるメッセージ。
    '
    '復帰コード
    '  標準処理: ローカル側の場合､ 規定のダイアログによる例外の表示。この中で例外スキップか終了処理かが決まる。
    '            セントル側の場合､ Dos プロンプト画面に表示して､ 処理を継続。
    Friend Const LOG_Standard As Integer = 0
    '  例外スキップの扱いとして処理を継続。
    Friend Const LOG_ExceptionSkip As Integer = 1 '★ SKIPABLE でない場合には､ LOG_ExceptionExit の指定と等価。
    '  終了処理を実施する。
    Friend Const LOG_ExceptionExit As Integer = 2
    '
    'Private AE_LogPointer As Integer = 0
    'Private AE_LogContents(100) As String

    Friend Overridable Function AE_Log(ByVal fB As AppliTech.WorkFrame.FormBase, ByVal pm_LogCode As Integer, ByVal pm_ex As System.Exception, ByVal ps_LogMsg As String) As Integer
#If CentralOrOp AndAlso Not LocalOrOp Then '"セントラル" 向け専用部分の開始。
        '★ ここでセントラル側のログをとってください。
        'AE_LogContents(AE_LogPointer) = fB.MainForm + Str(Microsoft.VisualBasic.DateAndTime.Timer()) + ": " + ps_LogMsg
        'AE_LogPointer += 1
        'If AE_LogPointer >= 100 Then AE_LogPointer = 0
        Return LOG_Standard '---------> '標準処理: 規定のダイアログによる例外の表示。この中で例外スキップか終了処理かが決まる。
        'Return LOG_ExceptionSkip '---------> '例外スキップの扱いとして処理を継続。
        'Return LOG_ExceptionExit '---------> '終了処理を実施する。
#End If '"セントラル" 向け専用部分の終了。
#If LocalOrOp OrElse Not CentralOrOp Then '"ローカル / ワンピース" 向け専用部分の開始。
        '★ ここでワンピース / ローカル側のログをとってください。
        '★ セントラル側で発生しローカルピースに転送された例外の場合､ pm_ex は Nothing となることに注意。
        'AE_LogContents(AE_LogPointer) = fB.MainForm + Str(Microsoft.VisualBasic.DateAndTime.Timer()) + ": " + ps_LogMsg
        'AE_LogPointer += 1
        'If AE_LogPointer >= 100 Then AE_LogPointer = 0
        Return LOG_Standard '---------> '標準処理: Dos プロンプト画面に表示して､ 処理を継続。
        'Return LOG_ExceptionSkip '---------> '例外スキップの扱いとして処理を継続。
        'Return LOG_ExceptionExit '---------> '終了処理を実施する。
#End If '"ローカル / ワンピース" 向け専用部分の終了。
    End Function 'AE_Log

    'セントラル / ローカル / ワンピース共通
    'System.Diagnostics.Debug.WriteLine 実行のためのアプリケーションイベント
#If DEBUG Then
    Friend Sub AE_Debug(ByVal fB As AppliTech.WorkFrame.FormBase, ByVal ps_DebugMsg As String) '削除 , ByVal pm_AvoidBug As Boolean)
        '削除 If Not pm_AvoidBug OrElse fB.IsCentralFormBase() Then
        System.Diagnostics.Debug.WriteLine(ps_DebugMsg)
        '削除 End If
    End Sub 'AE_Debug
#End If 'DEBUG

#If LocalOrOp OrElse Not CentralOrOp Then '"ローカル / ワンピース" 向け専用部分の開始。

    '☆非互換: 変数名 AE_NL$ を Microsoft.VisualBasic.Constants.vbCrLf に変更してください。
    '削除 Friend ReadOnly AE_NL As String = ch_Return + ch_LineFeed '= Microsoft.VisualBasic.Constants.vbCrLf
    '
    Friend ReadOnly ShiftJisEncoding As System.Text.Encoding = System.Text.Encoding.GetEncoding(932) '"shift_jis"
    Friend ReadOnly ch_Empty As Char = Microsoft.VisualBasic.Strings.ChrW(0)
    Friend ReadOnly ch_Return As Char = Microsoft.VisualBasic.Strings.ChrW(CType(System.Windows.Forms.Keys.Return, Integer))
    Friend ReadOnly ch_Back As Char = Microsoft.VisualBasic.Strings.ChrW(CType(System.Windows.Forms.Keys.Back, Integer))
    Friend ReadOnly ch_Escape As Char = Microsoft.VisualBasic.Strings.ChrW(CType(System.Windows.Forms.Keys.Escape, Integer))

    'ローカル / ワンピース用
    'キーイン可能な文字かどうかを判定するのためのアプリケーションイベント
    Friend Overridable Function AE_KeyInOkChar(ByVal fB As AppliTech.WorkFrame.FormBase, ByVal pm_Char As Char, ByVal pm_KeyInOkClass As Short) As Boolean
        Dim ch_CharsArray As Char()
        Select Case Microsoft.VisualBasic.Strings.ChrW(pm_KeyInOkClass) 'V4.L29
            Case ch_Empty 'chrEmpty
                Return False '--------->
            Case "0"c, "1"c, "2"c, "3"c '数字､ 数字 ＋ n 文字コード
                If pm_Char >= "0"c AndAlso pm_Char <= "9"c Then Return True '--------->
            Case "A"c 'Alphanumeric
                If pm_Char >= "A"c AndAlso pm_Char <= "Z"c Then
                    Return True '--------->
                ElseIf pm_Char >= "a"c AndAlso pm_Char <= "z"c Then
                    Return True '--------->
                ElseIf pm_Char >= "0"c AndAlso pm_Char <= "9"c Then
                    Return True '--------->
                ElseIf pm_Char = "-"c Then
                    Return True '--------->
                End If
            Case "B"c 'Basic Idetifier
                If pm_Char >= "A"c AndAlso pm_Char <= "Z"c Then
                    Return True '--------->
                ElseIf pm_Char >= "a"c AndAlso pm_Char <= "z"c Then
                    Return True '--------->
                ElseIf pm_Char >= "0"c AndAlso pm_Char <= "9"c Then
                    Return True '--------->
                ElseIf pm_Char = "_"c Then
                    Return True '--------->
                End If
                ch_CharsArray = New Char() {pm_Char}
                If ShiftJisEncoding.GetByteCount(ch_CharsArray) = 2 Then '２バイト文字
                    Return True '--------->
                End If
            Case "C"c 'Decimal
                If "0123456789+-. ".IndexOf(pm_Char) >= 0 Then Return True '--------->
                '
                '
                '------- 開発プロジェクトごとに定義する部分 (開始) --------
            Case "D"c 'Project Definition 1
                ch_CharsArray = New Char() {pm_Char}
                If ShiftJisEncoding.GetByteCount(ch_CharsArray) = 1 AndAlso pm_Char <> ch_Return AndAlso pm_Char <> ch_Back AndAlso pm_Char <> " "c Then Return True '---------> 'V4.L24
            Case "E"c 'Project Definition 2
                If pm_Char >= "｡"c AndAlso pm_Char <= "ﾟ"c Then
                    Return True '--------->
                ElseIf pm_Char >= "0"c AndAlso pm_Char <= "9"c Then
                    Return True '--------->
                ElseIf pm_Char = " "c Then
                    Return True '--------->
                End If
            Case "F"c 'Project Definition 3
                If pm_Char >= "A"c AndAlso pm_Char <= "Z"c Then
                    Return True '--------->
                ElseIf pm_Char >= "0"c AndAlso pm_Char <= "9"c Then
                    Return True '--------->
                ElseIf pm_Char = "-"c OrElse pm_Char = " "c Then
                    Return True '--------->
                End If
            Case "G"c 'Project Definition 4
                If pm_Char >= "A"c AndAlso pm_Char <= "Z"c Then
                    Return True '--------->
                ElseIf pm_Char >= "0"c AndAlso pm_Char <= "9"c Then
                    Return True '--------->
                ElseIf pm_Char = " "c Then
                    Return True '--------->
                End If
            Case "H"c 'Project Definition 5
                ch_CharsArray = New Char() {pm_Char}
                If ShiftJisEncoding.GetByteCount(ch_CharsArray) = 1 AndAlso pm_Char <> ch_Return AndAlso pm_Char <> ch_Back Then Return True '---------> 'V4.L34
                '------- 開発プロジェクトごとに定義する部分 (終了) --------
                '
                '
            Case "K"c 'Katakana
                If pm_Char >= "｡"c AndAlso pm_Char <= "ﾟ"c Then
                    Return True '--------->
                ElseIf pm_Char >= "0"c AndAlso pm_Char <= "9"c Then
                    Return True '--------->
                ElseIf pm_Char = " "c Then
                    Return True '--------->
                End If
            Case "L"c 'Lower Case
                If pm_Char >= "a"c AndAlso pm_Char <= "z"c Then
                    Return True '--------->
                ElseIf pm_Char >= "0"c AndAlso pm_Char <= "9"c Then
                    Return True '--------->
                ElseIf pm_Char = "-"c Then
                    Return True '--------->
                End If
            Case "M"c '２バイトコード
                If AppliTech.WorkFrame.FormBase.LenWid(pm_Char.ToString()) = 2 Then
                    Return True '--------->
                ElseIf pm_Char = " "c Then '後刻､ ２バイト文字の空白に変換。
                    Return True '--------->
                End If
            Case "N"c 'Nihongo (空白変換あり)
                If pm_Char <> ch_Return AndAlso pm_Char <> ch_Back AndAlso pm_Char <> ch_Escape Then Return True '--------->
            Case "S"c 'Single Byte
                ch_CharsArray = New Char() {pm_Char}
                If ShiftJisEncoding.GetByteCount(ch_CharsArray) = 1 AndAlso pm_Char <> ch_Return AndAlso pm_Char <> ch_Back AndAlso pm_Char <> " "c Then Return True '--------->
            Case "T"c '電話番号(Telephone Number)
                If "0123456789-".IndexOf(pm_Char) >= 0 Then Return True '--------->
            Case "U"c 'Upper Case
                If pm_Char >= "A"c AndAlso pm_Char <= "Z"c Then
                    Return True '--------->
                ElseIf pm_Char >= "0"c AndAlso pm_Char <= "9"c Then
                    Return True '--------->
                ElseIf pm_Char = "-"c Then
                    Return True '--------->
                End If
            Case "V"c 'Nihongo (空白変換なし)
                If pm_Char <> ch_Return AndAlso pm_Char <> ch_Back AndAlso pm_Char <> ch_Escape Then Return True '--------->
            Case "W"c '和暦
                If "MTSHmtsh".IndexOf(pm_Char) >= 0 Then
                    Return True '--------->
                ElseIf "0123456789明大昭平".IndexOf(pm_Char) >= 0 Then
                    Return True '--------->
                End If
            Case "Z"c '数字と空白
                If "0123456789 ".IndexOf(pm_Char) >= 0 Then Return True '--------->
            Case "-"c '一切の文字のインプットが不可
        End Select
        '
        Return False '--------->
    End Function 'AE_KeyInOkChar

    'ローカル / ワンピース用
    'メッセージ表示処理の実行のためのアプリケーションイベント
    'MsgBox の代わりにこの AE_MsgBox を用いることで､ その処理内容を一括して変更できるようになる。
    Friend Overridable Overloads Function AE_MsgBox(ByVal ps_Message As String) As Microsoft.VisualBasic.MsgBoxResult
        '★ Microsoft.VisualBasic.Interaction.MsgBox ではなく､ MessageBox.Show を用いないとうまく動作しない場合があるので注意。
        Return CType(MessageBox.Show(ps_Message), Microsoft.VisualBasic.MsgBoxResult) '--------->
    End Function 'AE_MsgBox
    Friend Overridable Overloads Function AE_MsgBox(ByVal ps_Message As String, ByVal pm_MsgStyle As Microsoft.VisualBasic.MsgBoxStyle) As Microsoft.VisualBasic.MsgBoxResult
        '★ Microsoft.VisualBasic.Interaction.MsgBox ではなく､ MessageBox.Show を用いないとうまく動作しない場合があるので注意。
        Dim wk_MsgStyle As Integer = CType(pm_MsgStyle, Integer)
        Return CType(MessageBox.Show(ps_Message, Nothing, _
        CType((wk_MsgStyle And &HF), MessageBoxButtons), _
        CType((wk_MsgStyle And &HF0), MessageBoxIcon), _
        CType((wk_MsgStyle And &H700), MessageBoxDefaultButton), _
        CType((wk_MsgStyle And &H3FFFF800), MessageBoxOptions)), Microsoft.VisualBasic.MsgBoxResult) '--------->
    End Function 'AE_MsgBox
    Friend Overridable Overloads Function AE_MsgBox(ByVal ps_Message As String, ByVal pm_MsgStyle As Microsoft.VisualBasic.MsgBoxStyle, ByVal ps_MsgTitle As String) As Microsoft.VisualBasic.MsgBoxResult
        '★ Microsoft.VisualBasic.Interaction.MsgBox ではなく､ MessageBox.Show を用いないとうまく動作しない場合があるので注意。
        Dim wk_MsgStyle As Integer = CType(pm_MsgStyle, Integer)
        Return CType(MessageBox.Show(ps_Message, ps_MsgTitle, _
        CType((wk_MsgStyle And &HF), MessageBoxButtons), _
        CType((wk_MsgStyle And &HF0), MessageBoxIcon), _
        CType((wk_MsgStyle And &H700), MessageBoxDefaultButton), _
        CType((wk_MsgStyle And &H3FFFF800), MessageBoxOptions)), Microsoft.VisualBasic.MsgBoxResult) '--------->
    End Function 'AE_MsgBox
    Friend Overridable Overloads Function AE_MsgBox(ByVal pm_owner As System.Windows.Forms.IWin32Window, ByVal ps_Message As String, ByVal pm_MsgStyle As Microsoft.VisualBasic.MsgBoxStyle, ByVal ps_MsgTitle As String) As Microsoft.VisualBasic.MsgBoxResult
        '★ Microsoft.VisualBasic.Interaction.MsgBox ではなく､ MessageBox.Show を用いないとうまく動作しない場合があるので注意。
        Dim wk_MsgStyle As Integer = CType(pm_MsgStyle, Integer)
        Return CType(MessageBox.Show(pm_owner, ps_Message, ps_MsgTitle, _
        CType((wk_MsgStyle And &HF), MessageBoxButtons), _
        CType((wk_MsgStyle And &HF0), MessageBoxIcon), _
        CType((wk_MsgStyle And &H700), MessageBoxDefaultButton), _
        CType((wk_MsgStyle And &H3FFFF800), MessageBoxOptions)), Microsoft.VisualBasic.MsgBoxResult) '--------->
    End Function 'AE_MsgBox
    Friend Overridable Overloads Function AE_MsgBox(ByVal pm_owner As System.Windows.Forms.IWin32Window, ByVal ps_Message As String, ByVal pm_MsgStyle As Microsoft.VisualBasic.MsgBoxStyle, ByVal ps_MsgTitle As String, ByVal pm_auxiliary As Object) As Microsoft.VisualBasic.MsgBoxResult
        '★ Microsoft.VisualBasic.Interaction.MsgBox ではなく､ MessageBox.Show を用いないとうまく動作しない場合があるので注意。
        Dim wk_MsgStyle As Integer = CType(pm_MsgStyle, Integer)
        Return CType(MessageBox.Show(pm_owner, ps_Message, ps_MsgTitle, _
        CType((wk_MsgStyle And &HF), MessageBoxButtons), _
        CType((wk_MsgStyle And &HF0), MessageBoxIcon), _
        CType((wk_MsgStyle And &H700), MessageBoxDefaultButton), _
        CType((wk_MsgStyle And &H3FFFF800), MessageBoxOptions)), Microsoft.VisualBasic.MsgBoxResult) '--------->
    End Function 'AE_MsgBox

    'ローカル / ワンピース用
    'メッセージの内容を決めるのためのアプリケーションイベント
    '
    'アプリの実行時に出力される標準メッセージ。
    '
    '  アプリの実行時に出力される標準メッセージを変更したり､ 出力を抑止したりするには､ 
    '従来のようにこのモジュールを修正してしまう道の他に､ 
    'このクラスを継承するサブクラスを作成する道ができました。

    '*** メソッド AE_MsgLibrary の中のメッセージを変更することが必要な場合には､ ***
    '*** このクラスを継承するサブクラスを作成して､ AE_MsgLibrary の全行をそのサ ***
    '*** ブクラスにコピーして､ Overridable を Overrides に変更してた上で､ メッ  ***
    '*** セージの内容を変更してください。                                       ***

    Friend Overridable Function AE_MsgLibrary(ByVal fB As AppliTech.WorkFrame.FormBase, ByVal ps_MsgCode As String, ByVal ps_AdditionalMsg As String) As Boolean 'Original
        '戻り値が False だと中断せずに処理を継続することを意味する。'Original
        '戻り値が True だと処理を中断することを意味する。'Original
        '
        Dim sg_Message As String 'Original
        Select Case ps_MsgCode.ToUpper() 'Original
            Case "APPEND" 'Original
                If Not fB.ExplicitExec Then 'Original
                    If fB.MessageBoxShow(fB.myForm, "伝票を発行します。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information, MessageBoxDefaultButton.Button2) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
                End If 'Original
            Case "APPENDC" 'Original
                If fB.MessageBoxShow(fB.myForm, "データエントリに移行します。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "CANCEL" 'Original
                If fB.MessageBoxShow(fB.myForm, "当初の画面データ復元の指示によって､ この画面データに関する変更はなかったとみなされて､ 当初の状態に戻ります。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "CLEARDE" 'Original
                fB.MessageBoxShow(fB.myForm, "ボディ部または拡張ボディ部に挿入されている初期化された明細行を削除してから､ この操作を行ってください。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "COMPLETEC" 'Original
                AE_Beep() 'Original
                sg_Message = "インプットの必要な項目が残っています。" 'Original
                sg_Message += Microsoft.VisualBasic.Constants.vbCrLf + "または､ エラーの項目かインプット途中の項目が残っています。" 'Original
                sg_Message += Microsoft.VisualBasic.Constants.vbCrLf + "インプットを完結させてください。" 'Original
                fB.MessageBoxShow(fB.myForm, sg_Message, fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "COPYDE", "COPYITEM" 'Original
                fB.MessageBoxShow(fB.myForm, "コピーすべき前行のデータが存在しません。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "CURRENT" 'Original
                If fB.LastEDe = 0 Then 'Original
                    If fB.MessageBoxShow(fB.myForm, "データが存在しません。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) = System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
                Else 'Original
                    Return True '---------> 'Original
                End If 'Original
            Case "CURSOR" 'Original
                sg_Message = "この上に空白の明細行があるので､ ここにデータをインプットすることはできません。" 'Original
                sg_Message += Microsoft.VisualBasic.Constants.vbCrLf + "カーソルを元の位置に戻します。" 'Original
                fB.MessageBoxShow(fB.myForm, sg_Message, fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "DELETECM" 'Original
                If fB.MessageBoxShow(fB.myForm, "伝票を削除します。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "ENDCK" 'Original
                If fB.CloseCode <> 11 Then 'Original
                    If fB.MessageBoxShow(fB.myForm, "終了すると､ インプット途中のデータが有効になりません。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Error) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
                End If 'Original
            Case "ENDCM" 'Original
                If fB.CloseCode <> 11 Then 'Original
                    If fB.MessageBoxShow(fB.myForm, "終了します。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Exclamation) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
                End If 'Original
            Case "FIRSTC" 'Original
                If fB.MessageBoxShow(fB.myForm, "先頭のレコードに移ります。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "FIRSTCM" 'Original
                fB.MessageBoxShow(fB.myForm, "データが存在しません。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "HARDCOPY" 'Original
                If fB.MessageBoxShow(fB.myForm, "画面のハードコピーを印刷します。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "HARDCOPYERROR" 'Original
                fB.MessageBoxShow(fB.myForm, "印刷の準備がなされていません。(" + fB.ExceptionOfPrintForm.Message + ")"c, fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Error) 'Original
            Case "HEADCOMPLETEC" 'Original
                AE_Beep()
                fB.StatusOut("ヘッド部のインプットを完結させてください。", COLOR_ErrorStatus) 'Original
            Case "INACTIVEDE" 'Original
                sg_Message = "ここにデータをインプットすることはできません。" 'Original
                sg_Message += Microsoft.VisualBasic.Constants.vbCrLf + "矢印キー､ またはマウス､ シフト + Tab キーでカーソルを上に移動してください。" 'Original
                fB.MessageBoxShow(fB.myForm, sg_Message, fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "INDICATE" 'Original
                If fB.MessageBoxShow(fB.myForm, "表示モードに変更してよいですか？ (一部のデータをインプットしていても､ なかったものとみなされます。)", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "INDICATEE" 'Original
                If fB.MessageBoxShow(fB.myForm, "この表示を終えてよいですか？", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information, MessageBoxDefaultButton.Button2) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "INSERTDE" 'Original
                fB.MessageBoxShow(fB.myForm, "ボディ部または拡張ボディ部に余裕がないために､ この操作はできません。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "LASTC" 'Original
                If fB.MessageBoxShow(fB.myForm, "最終のレコードに移ります。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "LASTCM" 'Original
                fB.MessageBoxShow(fB.myForm, "データが存在しません。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "NEXTC" 'Original
                If fB.MessageBoxShow(fB.myForm, "次のレコードに移ります。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "NEXTCM" 'Original
                fB.MessageBoxShow(fB.myForm, "この後ろにデータはありません。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "OUTPUTONLY" 'Original
                sg_Message = "この項目は出力専用ですから､ データをインプットすることはできません。" 'Original
                sg_Message += Microsoft.VisualBasic.Constants.vbCrLf + "矢印キー､ またはマウス､ Tab キーでカーソルを移動してください。" 'Original
                fB.MessageBoxShow(fB.myForm, sg_Message, fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "PRECHECK1" 'Original 'V4.L28
                fB.StatusOut("この項目にはインプットが必要です。", COLOR_ErrorStatus) 'Original 'V4.L28
            Case "PRECHECK2" 'Original 'V4.L28
                fB.StatusOut("この項目には左端から右端まで文字をインプットしてください。", COLOR_ErrorStatus) 'Original 'V4.L28
                '廃止 Case "QUERYUNLOAD" 'Original
                '廃止     fB.MessageBoxShow(fB.Caption + "が起動されています。" + Microsoft.VisualBasic.Constants.vbCrLf + "これを終了してから Windows を終了してください。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Case "PREVC" 'Original
                If fB.MessageBoxShow(fB.myForm, "一つ前のレコードに移ります。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "PREVCM" 'Original
                fB.MessageBoxShow(fB.myForm, "この前にデータはありません。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "RECALC" 'Original
                sg_Message = "ヘッド部またはテール部の項目を変更したため､ ボディ部または拡張ボディ部の項目に " 'Original
                sg_Message += fB.ErrorC.ToString() + " 個のエラーが検出されました。" 'Original
                sg_Message += Microsoft.VisualBasic.Constants.vbCrLf + "カーソルをエラーの項目に移動して修正してください。" 'Original
                fB.MessageBoxShow(fB.myForm, sg_Message, fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
            Case "RELCHECK" 'Original
                If Not fB.RecalcMode Then 'Original
                    fB.MessageBoxShow(fB.myForm, "この項目より先にデータエラーの項目を修正してください。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
                End If 'Original
            Case "SELECTCM" 'Original
                If fB.MessageBoxShow(fB.myForm, "選択モードに変更してよいですか？ (一部のデータをインプットしていても､ なかったものとみなされます。)", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "SELECTE" 'Original
                '削除 If Not fB.ExplicitExec Then 'Original
                '削除    If fB.MessageBoxShow(fB.myForm, "選択条件がインプットされました。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information, MessageBoxDefaultButton.Button2) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
                '削除 End If 'Original
            Case "UPDATE" 'Original
                If Not fB.ExplicitExec Then 'Original
                    If fB.MessageBoxShow(fB.myForm, "伝票を更新します。", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information, MessageBoxDefaultButton.Button2) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
                End If 'Original
            Case "UPDATE2" 'Original
                If fB.MessageBoxShow(fB.myForm, "何もインプットされていませんが､ 伝票を更新しますか？", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "UPDATEC" 'Original
                If fB.MessageBoxShow(fB.myForm, "更新モードに変更してよいですか？ (一部のデータをインプットしていても､ なかったものとみなされます。)", fB.MyTitle, MessageBoxButtons.OKCancel, MessageBoxIcon.Information) <> System.Windows.Forms.DialogResult.OK Then Return True '---------> 'Original
            Case "VERSIONERROR" 'Original
                fB.MessageBoxShow(fB.myForm, "バージョンレベルなどが異なるので､ プログラムの再合成､ またはフレームワークの参照に関する設定の変更が必要です。", fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Error) 'Original
            Case "CENTRALLOAD" 'Original
                fB.ShowException(ps_MsgCode, ps_AdditionalMsg, HeaderMessage)
            Case "CENTRALFORMLOAD" 'Original
                fB.ShowException(ps_MsgCode, ps_AdditionalMsg, HeaderMessage)
            Case Else 'Original
                sg_Message = "アプリケーション開発時に実施したメッセージの変更に問題があります。" 'Original
                sg_Message += Microsoft.VisualBasic.Constants.vbCrLf + "メッセージコード (" + ps_MsgCode + ") の受け口のプログラムがありません。" 'Original
                fB.MessageBoxShow(fB.myForm, sg_Message, fB.MyTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation) 'Original
        End Select 'Original
        '
        Return False '---------> 'Original
    End Function 'AE_MsgLibrary

    Protected Const HeaderMessage As String = "CentralMain などのサーバを立ち上げてから､ 再度､ 起動し直してください。"

    'ローカル / ワンピース用
    'アプリケーションプログラムを終了させるのためのアプリケーションイベント
    Friend Overridable Sub AE_Exit(ByVal fB As AppliTech.WorkFrame.FormBase)
        fB.Fadeout()
        'Dim sg_LogFileName As String = fB.MyBinPath + "@ApplLog.log" 'ログファイル名
        'Dim LogF As Integer = Microsoft.VisualBasic.FileSystem.FreeFile() 'File Number
        'Microsoft.VisualBasic.FileSystem.FileOpen(LogF, sg_LogFileName, Microsoft.VisualBasic.OpenMode.Output)
        'Microsoft.VisualBasic.FileSystem.PrintLine(LogF, "LogPointer = " + AE_LogPointer.ToString() + "     (Next Point to Log)")
        'Dim Wx As Integer = 0
        'While Wx <= 99
        '    Microsoft.VisualBasic.FileSystem.PrintLine(LogF, "Log(" + Microsoft.VisualBasic.Strings.Right("00" + Wx.ToString(), 2) + ") = " + """"c + AE_LogContents(Wx) + """"c)
        '    Wx += 1
        'End While 'Wx
        'Microsoft.VisualBasic.FileSystem.FileClose(LogF)
        'Stop '★
#If Not DotNetDll Then '.Net dll ではないアセンブリの場合
        fB.Dispose(True)
        System.Windows.Forms.Application.Exit()
        System.Environment.Exit(0) '★ 終了の Exit。
#End If '.Net dll ではないアセンブリの場合
    End Sub 'AE_Exit

#End If '"ローカル / ワンピース" 向け専用部分の終了。

    '========== Remoting 機能に関するプログラムの開始 ==========
#If LocalOrOp AndAlso Not CentralOrOp Then '"ローカル" 向け専用部分の開始。

    '*** AppliTech.Remoting の代わりに CCCAgent などの他の Remoting 機能を使用する場合には､  ***
    '*** このクラスを継承するサブクラスを作成して､ 数行上の ｢Remoting 機能に関するプログラム ***
    '*** の開始｣ から ｢Remoting 機能に関するプログラムの終了｣ までの約 100 行の文をそのサブ  ***
    '*** クラスにコピーしてください。そして､ そのサブクラスの中でメソッド AE_DoUpDownBytes   ***
    '*** およ び AE_StartUp を Overrides するようにしてください。このようにしてから､ これら  ***
    '*** のメソッドの内容を適当に変更すれば､ 他の Remoting 機能が使用できるようになります。  ***

    'セキュリティ関連フィールド
    Friend EnsureSecurity As Boolean = False 'セキュリティ使用(true)／不使用(false)
    Friend UseDefaultCredentials As Boolean = True 'ログイン情報流用(true)／別途指定(false)
    Friend maxRetryCount As Integer = 3 '最大リトライ回数
    Protected loginedCredential As System.Net.NetworkCredential = Nothing 'ログイン成功済み認証情報

    'ローカルピース専用
    'ローカル・セントラル間の通信を行うためのアプリケーションイベント
    Friend Overridable Function AE_DoUpDownBytes(ByVal fB As AppliTech.WorkFrame.FormBase, ByVal pm_Bytes As Byte()) As Byte()
        Dim canRetrySignOn As Boolean = False
        Dim retryCount As Integer = 0
        Dim credential As System.Net.NetworkCredential = Nothing
        Dim sg_AuthErrorMessage As String = String.Empty '認証エラーの詳細メッセージ
        While True
            Try
                If canRetrySignOn Then
                    Dim retryMessage As System.Text.StringBuilder = New System.Text.StringBuilder("認証に失敗しました。再試行しますか?")
                    If sg_AuthErrorMessage.Length > 0 Then
                        retryMessage.Append(System.Environment.NewLine)
                        retryMessage.Append(sg_AuthErrorMessage)
                    End If
                    Dim wk_dResult As System.Windows.Forms.DialogResult = fB.MessageBoxShow(retryMessage.ToString(), fB.MyTitle, MessageBoxButtons.RetryCancel, MessageBoxIcon.Error)
                    If wk_dResult = System.Windows.Forms.DialogResult.Cancel Then
                        '置換 Exit Do '---->
                        Exit While '---->
                    End If
                End If
#If HttpDirect Then '-Else-End If
                If EnsureSecurity Then
                    If UseDefaultCredentials Then
                        comm.SetCredential(System.Net.CredentialCache.DefaultNetworkCredentials)
                    Else
                        credential = New System.Net.NetworkCredential()
                        canRetrySignOn = AE_Login(fB, credential)
                        comm.SetCredential(credential)
                    End If
                End If
#Else 'Not HttpDirect
                If EnsureSecurity Then
                    If UseDefaultCredentials Then
                    Else
                        credential = New System.Net.NetworkCredential()
                        canRetrySignOn = AE_Login(fB, credential)
                        Dim proxyProperties As System.Collections.IDictionary = System.Runtime.Remoting.Channels.ChannelServices.GetChannelSinkProperties(comm)
                        If proxyProperties Is Nothing Then
                            Throw New AppliTech.WorkFrame.WorkFrameException("｢リモートオブジェクトの ChannelSinkProperties が取得できませんでした (Nothing)｣")
                        End If
                        proxyProperties("username") = credential.UserName
                        proxyProperties("password") = credential.Password
                    End If
                End If
#End If 'Not HttpDirect / 'HttpDirect
                Dim commData As Byte() = comm.UpDownBytes(pm_Bytes)
                If Not UseDefaultCredentials Then
                    'ログイン成功を通知
                    AE_LoginSuccessed(fB, credential)
                End If
                Return commData '--------->
            Catch ex11 As System.Security.Authentication.AuthenticationException
                sg_AuthErrorMessage = ex11.ToString()
            Catch ex22 As System.Net.WebException
                sg_AuthErrorMessage = ex22.ToString()
                If Not (ex22.Response Is Nothing) AndAlso TypeOf ex22.Response Is System.Net.HttpWebResponse Then
                    Dim resp As System.Net.HttpWebResponse = CType(ex22.Response, System.Net.HttpWebResponse)
                    If canRetrySignOn Then
                        If resp.StatusCode = System.Net.HttpStatusCode.Unauthorized OrElse _
                           resp.StatusCode = System.Net.HttpStatusCode.Forbidden Then
                            sg_AuthErrorMessage = "ユーザ認証に成功することができませんでした。" + Environment.NewLine + sg_AuthErrorMessage
                            Exit Try '---->
                        End If
                    End If
                End If
                Exit While '---->
            Catch ex As System.Exception
                If AE_Log(fB, EXCEPTION_ThisSystemLocalOrOp, ex, ex.GetBaseException().Message) = LOG_Standard Then
                    Dim wk_baseException As Exception = ex.GetBaseException()
                    If wk_baseException Is Nothing Then
                        sg_AuthErrorMessage = ex.ToString()
                    Else
                        sg_AuthErrorMessage = wk_baseException.ToString()
                    End If
                End If
                Exit While '---->
            End Try
            retryCount += 1
            If retryCount >= maxRetryCount Then Exit While '---->
        End While
        fB.ShowException("UpDownBytes", "サーバーコンピュータに接続できませんでした。" + Environment.NewLine + sg_AuthErrorMessage)
        Return Nothing '--------->
    End Function 'AE_DoUpDownBytes

#If HttpDirect Then '-Else-End If

    Friend Shared comm As AppliTech.WorkFrame.WebClientCommunicator 'Communicator のインスタンス
    '置換え候補 Friend Shared ServerURL As String = "http://192.168.0.9:8080/ServletApp/AppServlet"
    '置換え候補 Friend Shared ServerURL As String = "http://www.applitech.jp:8080/ServletApp/AppServlet"
    '置換え候補 Friend Shared ServerURL As String = "http://localhost:8080/ServletApp/AppServlet"
    '置換え候補 Friend Shared ServerURL As String = "http://localhost:8080/WebServer/AppRequest.appmsg"
    Friend Shared ServerURL As String = "http://localhost/WebServer/AppRequest.appmsg"

    'ローカルピース専用
    'ローカル・セントラル間の通信をスタートアップさせるためのアプリケーションイベント
    Friend Overridable Sub AE_StartUp(ByVal fB As AppliTech.WorkFrame.FormBase)
        AE_Configuration(fB)
        Dim sg_MessageTitle As String = Nothing
        Dim sg_Message As String = Nothing
        If fB.parentFB Is Nothing Then
            Dim wk_exception As System.Exception = Nothing
            Try
                sg_MessageTitle = "コミュニケータのコンストラクト時のエラー。"
                '
                comm = New AppliTech.WorkFrame.WebClientCommunicator(ServerURL) 'Communicator クラス変更
                comm.SetProxy(System.Net.WebRequest.DefaultWebProxy) 'Proxy の指定。
                fB.baseComm = comm
                If comm Is Nothing Then sg_Message = "コミュニケータをコンストラクトできません。"
            Catch ex As System.Exception
                wk_exception = ex
                sg_Message = ex.GetBaseException().Message
            End Try
            If Not (sg_Message Is Nothing OrElse sg_Message.Length = 0) Then
                If AE_Log(fB, EXCEPTION_ThisSystemLocalOrOp, wk_exception, wk_exception.GetBaseException().Message) = LOG_Standard Then
                    fB.ShowException(sg_MessageTitle, sg_Message, HeaderMessage)
                End If
            End If
        Else
            comm = CType(fB.baseComm, AppliTech.WorkFrame.WebClientCommunicator) 'Communicator クラス変更
        End If
    End Sub 'AE_StartUp

#Else 'Not HttpDirect 'If Remoting

    Friend Shared comm As AppliTech.Remoting.Communicator 'Communicator のインスタンス
    Friend Shared ServerURL As String = "http://localhost:8080/REMOTING" 'HttpChannel の場合の例
    '置換え候補 Friend Shared ServerURL As String = "tcp://localhost:9090/REMOTING" 'TcpChannel の場合の例
    '置換え候補 Friend Shared ServerURL As String = "http://localhost:8080/WebServer/Communicator.rem" 'HttpChannel/IIS の場合の例
    Friend Shared CommunicatorTypeName As String = "AppliTech.Remoting.Communicator"
    Friend Shared CommunicatorAssemblyName As String = "AppliTech.Remoting10" '"AppliTech.Remoting10Sample"

    'ローカルピース専用
    'ローカル・セントラル間の通信をスタートアップさせるためのアプリケーションイベント
    Friend Overridable Sub AE_StartUp(ByVal fB As AppliTech.WorkFrame.FormBase)
        AE_Configuration(fB)
        Dim sg_MessageTitle As String = Nothing
        Dim sg_Message As String = Nothing
        If fB.parentFB Is Nothing Then
            Dim wk_exception As System.Exception = Nothing
            Try
                sg_MessageTitle = "Channel のコンストラクト時のエラー。"
                Dim channelProperties As System.Collections.Specialized.ListDictionary = New System.Collections.Specialized.ListDictionary
                channelProperties.Add("port", 0)
                channelProperties.Add("name", String.Empty)
                channelProperties.Add("useDefaultCredentials", UseDefaultCredentials) '現在ログインしているユーザ名でサーバ認証を受けます
                '参考 channelProperties.Add("proxyName", "プロキシサーバの名前")
                '参考 channelProperties.Add("proxyPort", プロキシサーバのポート番号)
                Dim channel As System.Runtime.Remoting.Channels.IChannel
                If ServerURL.StartsWith("http:") OrElse ServerURL.StartsWith("https:") Then
                    channel = New System.Runtime.Remoting.Channels.Http.HttpClientChannel(channelProperties, Nothing)
                ElseIf ServerURL.StartsWith("tcp:") Then
                    channel = New System.Runtime.Remoting.Channels.Tcp.TcpClientChannel(channelProperties, Nothing)
                Else
                    Throw New AppliTech.WorkFrame.WorkFrameException("｢ServerURL の内容が正しくありません (http:, https: または tcp: で始まる文字列にしてください)｣")
                End If
                '
                sg_MessageTitle = "通信用の channel 登録時のエラー。"
                Try
                    '置換 System.Runtime.Remoting.Channels.ChannelServices.RegisterChannel(channel, False)
                    '置換 sg_MessageTitle = "リモートオブジェクト取得時のエラー。"
                    '置換 System.Runtime.Remoting.RemotingConfiguration.RegisterWellKnownClientType(Type.GetType("AppliTech.Remoting.Communicator, " + CommunicatorAssemblyName), ServerURL)
                    '置換 Dim sg_TypeName As String = "AppliTech.Remoting.Communicator, " + CommunicatorAssemblyName
                    Dim sg_TypeName As String = CommunicatorTypeName + ", " + CommunicatorAssemblyName
                    Dim wk_type As Type = Type.GetType(sg_TypeName)
                    If wk_type Is Nothing Then
                        Throw New AppliTech.WorkFrame.WorkFrameException("｢型""" + sg_TypeName + """が見つからないためサーバへの接続ができませんでした｣")
                    End If
                    Dim wk_entry As System.Runtime.Remoting.WellKnownClientTypeEntry = System.Runtime.Remoting.RemotingConfiguration.IsWellKnownClientType(wk_type)
                    If wk_entry Is Nothing Then
                        System.Runtime.Remoting.Channels.ChannelServices.RegisterChannel(channel, EnsureSecurity) 'EnsureSecurity 変数を使用
                        sg_MessageTitle = "リモートオブジェクト取得時のエラー。"
                        System.Runtime.Remoting.RemotingConfiguration.RegisterWellKnownClientType(wk_type, ServerURL)
                    Else
                        Console.WriteLine("ClientTypeEntry is Registered And Name=""{0}"" Url=""{1}""", wk_entry.ObjectType.Name, wk_entry.ObjectUrl.ToString())
                    End If
                Catch ex As System.Runtime.Remoting.RemotingException
                    '置換 If Not ex.Message.Equals("チャネル http はすでに登録されています。") Then Throw ex
                    If Not ex.Message.Equals("チャネル 'http' はすでに登録されています。") AndAlso Not ex.Message.Equals("チャネル 'tcp' はすでに登録されています。") Then Throw ex 'tcp 追加
                End Try
                '
                sg_MessageTitle = "リモートオブジェクトのコンストラクト時のエラー。"
                comm = New AppliTech.Remoting.Communicator
                fB.baseComm = comm
                If comm Is Nothing Then sg_Message = "リモートオブジェクトをコンストラクトできません。"
            Catch ex As System.Exception
                wk_exception = ex
                sg_Message = ex.GetBaseException().Message
            End Try
            If Not (sg_Message Is Nothing OrElse sg_Message.Length = 0) Then
                If AE_Log(fB, EXCEPTION_ThisSystemLocalOrOp, wk_exception, wk_exception.GetBaseException().Message) = LOG_Standard Then
                    fB.ShowException(sg_MessageTitle, sg_Message, HeaderMessage)
                End If
            End If
        Else
            comm = CType(fB.baseComm, AppliTech.Remoting.Communicator)
        End If
    End Sub 'AE_StartUp

#End If 'Not HttpDirect / 'HttpDirect 'Not HttpDirect: Remoting

    'アプリケーション設定を構成ファイルなどから取得する。
    Protected Sub AE_Configuration(ByVal fB As AppliTech.WorkFrame.FormBase)
        'リモート処理サーバの URL を取得します
        Dim sg_ServerUrl As String = AppliTech.WorkFrame.FormBase.GetAppSetting("CentralServerURL")
        If Not (sg_ServerUrl Is Nothing) Then
            ServerURL = sg_ServerUrl
        End If
        'セキュリティ有無を取得する。
        Dim sg_EnsureSecurity As String = AppliTech.WorkFrame.FormBase.GetAppSetting("EnsureSecurity")
        If Not (sg_EnsureSecurity Is Nothing) Then
            EnsureSecurity = (String.Compare(sg_EnsureSecurity, "True", True) = 0)
        End If
        '既定の資格情報による認定を行うかどうかを取得する。
        Dim sg_UseDefaultCredentials As String = AppliTech.WorkFrame.FormBase.GetAppSetting("UseDefaultCredentials")
        If Not (sg_UseDefaultCredentials Is Nothing) Then
            UseDefaultCredentials = (String.Compare(sg_UseDefaultCredentials, "True", True) = 0)
        End If
        'ログイン時の最大リトライ回数を取得する。
        Dim sg_MaxRetryCountStr As String = AppliTech.WorkFrame.FormBase.GetAppSetting("MaxRetryCount")
        Dim wk_maxRetryCount As Integer = -1
        Dim wk_maxRetryCountIsRight As Boolean = Integer.TryParse(sg_MaxRetryCountStr, wk_maxRetryCount)
        If wk_maxRetryCountIsRight AndAlso wk_maxRetryCount > 0 Then
            maxRetryCount = wk_maxRetryCount
        End If
    End Sub 'AE_Configuration

    'ログイン処理を行うために呼び出されます。
    Protected Friend Overridable Function AE_Login(ByVal fB As AppliTech.WorkFrame.FormBase, ByVal credential As System.Net.NetworkCredential) As Boolean
        If loginedCredential Is Nothing Then
            Dim myLoginForm As AppliTech.WorkFrame.LoginForm = AppliTech.WorkFrame.LoginForm.Login(fB.myForm)
            If myLoginForm Is Nothing Then
                fB.EmergencyExit()
            End If
            credential.UserName = myLoginForm.UserName
            credential.Password = myLoginForm.Password
            Return True '--------->
        Else
            credential.UserName = loginedCredential.UserName
            credential.Password = loginedCredential.Password
            Return False '--------->
        End If
    End Function 'AE_Login

    'ログイン処理が成功した場合に呼び出されます。
    Protected Friend Overridable Sub AE_LoginSuccessed(ByVal fB As AppliTech.WorkFrame.FormBase, ByVal credential As System.Net.NetworkCredential)
        loginedCredential = credential
    End Sub 'AE_LoginSuccessed

#End If '"ローカル" 向け専用部分の終了。
    '========== Remoting 機能に関するプログラムの終了 ==========

    Friend Shared Function GetIntegerV(ByVal pm_wrpInteger As AppliTech.WorkFrame.WrpInteger) As Integer
        If pm_wrpInteger Is Nothing Then
            Return 0 '--------->
        Else
            Return pm_wrpInteger.intValue() '--------->
        End If
    End Function 'GetIntegerV

#If Not java Then
    Friend Shared Function GetDecimalV(ByVal pm_wrpDecimal As AppliTech.WorkFrame.WrpDecimal) As Decimal
        If pm_wrpDecimal Is Nothing Then
            Return 0D '--------->
        Else
            Return pm_wrpDecimal.DecimalV '--------->
        End If
    End Function 'GetDecimalV
#End If 'Not java

    Friend Shared Function GetStringV(ByVal ps_String As String) As String
        If ps_String Is Nothing Then
            Return String.Empty '--------->
        Else
            Return ps_String '--------->
        End If
    End Function 'GetStringV

    Friend Shared Function GetBooleanV(ByVal pm_wrpBoolean As AppliTech.WorkFrame.WrpBoolean) As Boolean
        If pm_wrpBoolean Is Nothing Then
            Return False '--------->
        Else
            Return pm_wrpBoolean.booleanValue() '--------->
        End If
    End Function 'GetBooleanV

End Class 'Ae_MsgL0
