﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。
Imports AppliTech.WorkFrame
Imports VB = Microsoft.VisualBasic

Friend Class 受注個数

    'データ項目部品 ｢受注個数｣

    '#Region "ローカルピース､ セントラルピース共通に用いるフックメソッドなど"
    '    'なし
    '#End Region 'ローカルピース､ セントラルピース共通に用いるフックメソッドなど

#Region "ローカルピースに配置するフックメソッドなど"
#If LocalOrOp OrElse Not CentralOrOp Then

    '受注個数と商品コードが両方とも空欄でない場合だけカーソルを留める。
    Friend Function スキップ(ByVal fB As FormBase, ByVal 受注個数 As WrpDecimal, ByVal 商品コード As String) As Boolean
        If 受注個数 Is Nothing AndAlso 商品コード = String.Empty Then
            If fB.CursorDirection = 4 Then fB.CursorDirection = 2 '1: Next, 2: Prev, 3:Down, 4:Up
            Return ItemBase.SKIP_True '----------
        Else
            Return ItemBase.SKIP_False '----------
        End If
    End Function 'スキップ

    'エラーメッセージを表示する (Response)。
    Friend Function 応答表示(ByVal fB As FormBase, ByVal Cd_Error As Integer) As Boolean
        If Cd_Error <> 0 Then
            Dim メッセージ As String
            Select Case Cd_Error
                Case 400
                    メッセージ = "１以上の数にしてください。"
                Case 401
                    メッセージ = "10,000 より小さい数にしてください。"
                Case Else
                    メッセージ = "登録されていないメッセージ " + Cd_Error.ToString() + " です。"
            End Select
            fB.Beep()
            fB.StatusOut(メッセージ, System.Drawing.Color.Red)
        End If
        Return True
    End Function '応答表示

#End If
#End Region 'ローカルピースに配置するフックメソッドなど

#Region "セントラルピースに配置するフックメソッドなど"
#If CentralOrOp OrElse Not LocalOrOp Then

    '受注個数が入力された場合に，そのチェックを行う。
    Friend Function 入力チェック(ByVal 受注個数 As WrpDecimal) As Integer
        If 受注個数 Is Nothing Then
            Return ItemBase.CHECK_OK '---------- '正常終了。
        ElseIf 受注個数.DecimalV = 0 Then
            Return 400 '---------- 'エラーコード 400。
        ElseIf 受注個数.DecimalV >= 10000 Then
            Return 401 '---------- 'エラーコード 401。
        Else
            Return ItemBase.CHECK_OK '---------- '正常終了。
        End If
    End Function '入力チェック

#End If
#End Region 'セントラルピースに配置するフックメソッドなど

End Class '受注個数
