﻿Option Strict On
Option Explicit On 
'☆ このソースコードの解読は､ 許諾されています。
'#SkipAnalysis このモジュールには、MANDALA フックメソッドが含まれていないので、MANDALA による解析処理の対象から外します。
Imports AppliTech.WorkFrame
Imports Jutyu.AppliFrame.DBMS

Friend Class 受注Table : Inherits TextDBMS

    '受注 (Jutyu) テーブルに関するレコード定義および各種メソッドなど

#If CentralOrOp OrElse Not LocalOrOp Then 'ワンピースまたはセントラルピース用 (つまりローカルピースを除く)

    'レコード定義
    Friend 受注コード As String 'FixedString(6)
    Friend 明細数 As String 'FixedString(3)
    Friend 受注日付 As String 'FixedString(10)
    Friend 発注元コード As String 'FixedString(6)
    Friend 注釈 As String 'FixedString(50)
    '
    Private Const RecordLength As Integer = 75

    'コンストラクタ
    Friend Sub New(ByVal pm_Filename As String)
        MyBase.New(pm_Filename, RecordLength)
    End Sub 'New

    Protected Overrides Sub Serialize()
        受注コード = AlignLeft(受注コード, 6)
        明細数 = AlignRight(明細数, 3)
        受注日付 = AlignLeft(受注日付, 10)
        発注元コード = AlignLeft(発注元コード, 6)
        注釈 = AlignLeft(注釈, 50)
        Record = 受注コード + 明細数 + 受注日付 + 発注元コード + 注釈
    End Sub 'Serialize

    Protected Overrides Sub DeSerialize()
        受注コード = FormBase.MidWid(Record, 1, 6)
        明細数 = FormBase.MidWid(Record, 7, 3)
        受注日付 = FormBase.MidWid(Record, 10, 10)
        発注元コード = FormBase.MidWid(Record, 20, 6)
        注釈 = FormBase.MidWid(Record, 26, 50)
    End Sub 'DeSerialize

    Public Overrides Function GetUniqueKey() As String
        'ユニークキー： 受注コード
        Return FormBase.MidWid(Record, 1, 6) '----------
    End Function 'GetUniqueKey

#End If 'ワンピースまたはセントラルピース用 (つまりローカルピースを除く)

End Class '受注Table
