﻿Option Strict On
Option Explicit On 
'☆ このソースコードの解読は､ 許諾されています。
'#SkipAnalysis このモジュールには、MANDALA フックメソッドが含まれていないので、MANDALA による解析処理の対象から外します。
Imports AppliTech.WorkFrame
Imports Jutyu.AppliFrame.DBMS

Friend Class 商品Table : Inherits TextDBMS

    '商品 (Syohn) テーブルに関するレコード定義および各種メソッドなど

#If CentralOrOp OrElse Not LocalOrOp Then 'ワンピースまたはセントラルピース用 (つまりローカルピースを除く)

    'レコード定義
    Friend 商品コード As String 'FixedString(8)
    Friend 商品名称 As String 'FixedString(20)
    Friend 商品単価 As String 'FixedString(6)
    '
    Private Const RecordLength As Integer = 34

    'コンストラクタ
    Friend Sub New(ByVal pm_Filename As String)
        MyBase.New(pm_Filename, RecordLength)
    End Sub 'New

    Protected Overrides Sub Serialize()
        商品コード = AlignLeft(商品コード, 8)
        商品名称 = AlignLeft(商品名称, 20)
        商品単価 = AlignRight(商品単価, 6)
        Record = 商品コード + 商品名称 + 商品単価
    End Sub 'Serialize

    Protected Overrides Sub DeSerialize()
        商品コード = FormBase.MidWid(Record, 1, 8)
        商品名称 = FormBase.MidWid(Record, 9, 20)
        商品単価 = FormBase.MidWid(Record, 29, 6)
    End Sub 'DeSerialize

    Public Overrides Function GetUniqueKey() As String
        'ユニークキー： 商品コード
        Return FormBase.MidWid(Record, 1, 8) '----------
    End Function 'GetUniqueKey

#End If 'ワンピースまたはセントラルピース用 (つまりローカルピースを除く)

End Class '商品Table
