﻿Option Strict On
Option Explicit On
'☆ このソースコードの解読は､ 許諾されています。

Imports AppliTech.WorkFrame
Imports Jutyu.AppliFrame.SListBases
Imports VB = Microsoft.VisualBasic

Friend Class Dlg受注コード

    '◆ Jutyu2 では､ セントラルとローカル間でデータの転送を行うように変更しました。
    '削除 'セントラルとローカル間､ および複数のフックメソッド間の連絡域 Common
    '削除 Friend Interface Common
    '削除     ReadOnly Property 受注レコード() As 受注Table '★ 親クラスの型にはしない。
    '削除     ReadOnly Property 発注元レコード() As 発注元Table '★ 親クラスの型にはしない。
    '削除 End Interface 'Common

    Private fB As FormBase
    Private iB_受注コード As ItemBase

    'コンストラクタ
    Sub New()
        MyBase.New()
        ' この呼び出しは、Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後で初期化を追加します。

    End Sub 'New

    'コンストラクタ
    Friend Sub New(ByVal fB As FormBase, ByVal iB_受注コード As ItemBase)
        Me.New()
        Me.fB = fB
        Me.iB_受注コード = iB_受注コード
    End Sub 'New

    Private AlreadyLoaded As Boolean = False

    '親クラスを Overrides した分も含めて２回呼び出されることに注意。
    'Overrides ではなく Shadows とすると､ 親クラスの MyBase.Load イベントハンドラが呼び出されてしまうのでダメ。
    'フラグ AlreadyLoaded で対処。
    Protected Overrides Sub SListBase_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Debug.WriteLine("受注コード SListBase_Load")
        If Me.AlreadyLoaded Then Return '----------
        '
        Me.AlreadyLoaded = True
        Me.BackColor = System.Drawing.ColorTranslator.FromOle(&HC0FFFF)
        Me.Text = "受注伝票の一覧"
        Me.TitlesLabel.Text = "コード   日付        発注元名"
        MyBase.CharsInItemsList = 42
        MyBase.RowsInItemsList = 10 '10 行のリスト
        '
        'リストボックスItemsList の内容の設定
        'Me.ItemsList.Sorted = True
        Me.ItemsList.Items.Clear()
        '
        '◆ Jutyu2 では､ SList のデータをセントラルとローカル間で転送するように変更しました。
        '置換 Dim co As Common = CType(fB.getCommon(), Common)
        '置換 co.受注レコード.SetCursorForAllRecords()
        '置換 Dim wk_Return As Integer = co.受注レコード.ReadSequential()
        '置換 While wk_Return = 0
        '置換     Dim 復帰コード As Integer = co.発注元レコード.SelectEqual(co.受注レコード.発注元コード)
        '置換     If 復帰コード <> 0 Then co.発注元レコード.発注元名称 = "(不明)" + VB.Strings.Space(18)
        '置換     Me.ItemsList.Items.Add(co.受注レコード.受注コード + "  " + co.受注レコード.受注日付 + "  " + co.発注元レコード.発注元名称)
        '置換     wk_Return = co.受注レコード.ReadSequential()
        '置換 End While
        Dim JutyuCdObj As Serializables.JutyuCd = CType(fB.invokeCentral("ForSList"), Serializables.JutyuCd)
        Dim I As Integer
        For I = 0 To JutyuCdObj.レコード数 - 1
            Me.ItemsList.Items.Add(JutyuCdObj.受注コード(I) + "  " + JutyuCdObj.受注日付(I) + "  " + JutyuCdObj.発注元名称(I))
        Next I
        '
        If Me.ItemsList.Items.Count > 0 Then Me.ItemsList.SelectedIndex = 0
    End Sub 'SListBase_Load

    Protected Overrides Sub OkButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OkButton.Click
        SListReturn = FormBase.MidWid(Me.ItemsList.Text, 1, 6) '●適当な修正が必要です。X: Sl_SList 上の開始位置。
        CType(fB, 受注業務FormBase).sListCom = SListReturn
    End Sub 'OkButton_Click

End Class 'Dlg受注コード
