﻿Option Strict On
Option Explicit On 
'☆ このソースコードの解読は､ 許諾されています。
'#SkipAnalysis このモジュールには、MANDALA フックメソッドが含まれていないので、MANDALA による解析処理の対象から外します。
Imports AppliTech.WorkFrame
Imports Jutyu.AppliFrame.DBMS

Friend Class 発注元Table : Inherits TextDBMS

    '発注元 (Hatmt) テーブルに関するレコード定義および各種メソッドなど

#If CentralOrOp OrElse Not LocalOrOp Then 'ワンピースまたはセントラルピース用 (つまりローカルピースを除く)

    'レコード定義
    Friend 発注元コード As String 'FixedString(6)
    Friend 発注元名称 As String 'FixedString(24)
    Friend 発注元種別 As String 'FixedString(1)
    '
    Private Const RecordLength As Integer = 31

    'コンストラクタ
    Friend Sub New(ByVal pm_Filename As String)
        MyBase.New(pm_Filename, RecordLength)
    End Sub 'New

    Protected Overrides Sub Serialize()
        発注元コード = AlignLeft(発注元コード, 6)
        発注元名称 = AlignLeft(発注元名称, 24)
        発注元種別 = AlignLeft(発注元種別, 1)
        Record = 発注元コード + 発注元名称 + 発注元種別
    End Sub 'Serialize

    Protected Overrides Sub DeSerialize()
        発注元コード = FormBase.MidWid(Record, 1, 6)
        発注元名称 = FormBase.MidWid(Record, 7, 24)
        発注元種別 = FormBase.MidWid(Record, 31, 1)
    End Sub 'DeSerialize

    Public Overrides Function GetUniqueKey() As String
        'ユニークキー： 発注元コード
        Return FormBase.MidWid(Record, 1, 6) '----------
    End Function 'GetUniqueKey

#End If 'ワンピースまたはセントラルピース用 (つまりローカルピースを除く)

End Class '発注元Table
