﻿Option Strict On
Option Explicit On 
'☆ このソースコードの解読は､ 許諾されています。
'#SkipAnalysis このモジュールには、MANDALA フックメソッドが含まれていないので、MANDALA による解析処理の対象から外します。
Imports AppliTech.WorkFrame
Imports Jutyu.AppliFrame.DBMS

Friend Class 受注明細Table : Inherits TextDBMS

    '受注 (Jutyu) 明細テーブルに関するレコード定義および各種メソッドなど

#If CentralOrOp OrElse Not LocalOrOp Then 'ワンピースまたはセントラルピース用 (つまりローカルピースを除く)

    'レコード定義
    Friend 受注コード As String 'FixedString(6)
    Friend 明細番号 As String 'FixedString(3)
    Friend 商品コード As String 'FixedString(8)
    Friend 商品単価 As String 'FixedString(6)
    Friend 受注個数 As String 'FixedString(4)
    Friend 受注金額 As String 'FixedString(10)
    '
    Private Const RecordLength As Integer = 37

    'コンストラクタ
    Friend Sub New(ByVal pm_Filename As String)
        MyBase.New(pm_Filename, RecordLength)
    End Sub 'New

    Protected Overrides Sub Serialize()
        受注コード = AlignLeft(受注コード, 6)
        明細番号 = AlignRight(明細番号, 3)
        商品コード = AlignLeft(商品コード, 8)
        商品単価 = AlignRight(商品単価, 6)
        受注個数 = AlignRight(受注個数, 4)
        受注金額 = AlignRight(受注金額, 10)
        Record = 受注コード + 明細番号 + 商品コード + 商品単価 + 受注個数 + 受注金額
    End Sub 'Serialize

    Protected Overrides Sub DeSerialize()
        受注コード = FormBase.MidWid(Record, 1, 6)
        明細番号 = FormBase.MidWid(Record, 7, 3)
        商品コード = FormBase.MidWid(Record, 10, 8)
        商品単価 = FormBase.MidWid(Record, 18, 6)
        受注個数 = FormBase.MidWid(Record, 24, 4)
        受注金額 = FormBase.MidWid(Record, 28, 10)
    End Sub 'DeSerialize

    Public Overrides Function GetUniqueKey() As String
        'ユニークキー： 受注コード + 明細番号
        Return FormBase.MidWid(Record, 1, 6) + FormBase.MidWid(Record, 7, 3) '----------
    End Function 'GetUniqueKey

#End If 'ワンピースまたはセントラルピース用 (つまりローカルピースを除く)

End Class '受注明細Table
