﻿Option Strict On
Option Explicit On 
'☆ このソースコードの解読は､ 許諾されています。
'Imports 受注業務.受注業務FormBase '(ii_xxxx 参照用)
Imports AppliTech.WorkFrame
Imports VB = Microsoft.VisualBasic

Friend Class 商品単価

    'データ項目部品 ｢商品単価｣

    'セントラルとローカル間､ および複数のフックメソッド間の連絡域
    Friend Interface Common
#If CentralOrOp OrElse Not LocalOrOp Then
        ReadOnly Property 商品レコード() As 商品Table '★ 親クラスの型にはしない。
#End If
    End Interface 'Common

    '#Region "ローカルピース､ セントラルピース共通に用いるフックメソッドなど"
    '    'なし
    '#End Region 'ローカルピース､ セントラルピース共通に用いるフックメソッドなど

#Region "ローカルピースに配置するフックメソッドなど"
#If LocalOrOp OrElse Not CentralOrOp Then

    '商品コードと受注個数が空欄でない場合だけカーソルを留める。
    Friend Function スキップ(ByVal fB As FormBase, ByVal 商品コード As String, ByVal 受注個数 As WrpDecimal) As Boolean
        If 商品コード = String.Empty Then
            If fB.CursorDirection = 4 Then fB.CursorDirection = 2 '1: Next, 2: Prev, 3:Down, 4:Up
            Return ItemBase.SKIP_True '----------
        ElseIf 受注個数 Is Nothing Then
            Return ItemBase.SKIP_True '----------
        Else
            Return ItemBase.SKIP_False '----------
        End If
    End Function 'スキップ

    'エラーメッセージを表示する (Response)。
    Friend Function 応答表示(ByVal fB As FormBase, ByVal Cd_Error As Integer) As Boolean
        If Cd_Error <> 0 Then
            Dim メッセージ As String
            Select Case Cd_Error
                Case 500
                    メッセージ = "商品単価に誤りがあります。"
                Case Else
                    メッセージ = "登録されていないメッセージ " + Cd_Error.ToString() + " です。"
            End Select
            fB.Beep()
            fB.StatusOut(メッセージ, System.Drawing.Color.Red)
        End If
        Return True
    End Function '応答表示

#End If
#End Region 'ローカルピースに配置するフックメソッドなど

#Region "セントラルピースに配置するフックメソッドなど"
#If CentralOrOp OrElse Not LocalOrOp Then

    '商品単価が入力された場合に、そのチェックを行う。
    Friend Function 入力チェック(ByVal fB As FormBase, ByVal 商品単価 As WrpDecimal, ByVal 商品コード As String, ByVal De_Index As Integer) As Integer
        If 商品単価 Is Nothing Then
            Return 500 '----------
        ElseIf 商品単価.DecimalV = 0 Then
            Return 500 '----------
        Else
            Dim co As Common = CType(fB.getCommon(), Common)
            If 商品コード = String.Empty Then
            ElseIf Not fB.RecalcMode AndAlso 商品単価.DecimalV <> CDec(co.商品レコード.商品単価) Then
                '手入力フラグを立てる
                fB.setValue(ii_手入力, De_Index, "1")
            End If
        End If
        Return ItemBase.CHECK_OK '---------- '正常終了。
    End Function '入力チェック

    '商品単価を表示する。
    Friend Function 派生値(ByVal fB As FormBase, ByVal 商品コード As String, ByVal 商品単価 As WrpDecimal, ByVal 手入力 As String) As WrpDecimal
        If 商品コード = String.Empty Then
            '商品コードがクリアされている場合
            Return Nothing '----------
        ElseIf 手入力 = String.Empty Then
            '商品単価が手入力されていない場合
            Dim co As Common = CType(fB.getCommon(), Common)
            Return New WrpDecimal(co.商品レコード.商品単価) '----------
        Else
            '商品単価が手入力されている場合
            'Return New WrpDecimal(商品単価.DecimalV) '----------
            Return 商品単価 '----------
        End If
    End Function '派生値

#End If
#End Region 'セントラルピースに配置するフックメソッドなど

End Class '商品単価
